#include "ast.hpp"
#include "pattern.hpp"
#include "parser.hpp"
#include "gmachine.hpp"
#include "llvm.hpp"
#include <sstream>

int main() {
    try {
        std::ostringstream oss;
        oss << std::cin.rdbuf();
        std::string input = oss.str();

        lily::program_ptr prog = lily::parse(input);
        prog->gen_llvm();
    } catch(lily::error& e) {
        std::cout << e.message << std::endl;
    }
}
